/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_AbnormalLinesFindingOrFeature;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_AbnormalLinesFindingOrFeature;


/**
 * This class represents AbnormalLinesFindingOrFeature - CID6103
 */
public class AbnormalLinesFindingOrFeature_CID6103
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Instantiates a new AbnormalLinesFindingOrFeature_CID6103 Template 
	 */
	public AbnormalLinesFindingOrFeature_CID6103()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumAbnormalLinesFindingOrFeature Object of EnumCM_AbnormalLinesFindingOrFeature represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_AbnormalLinesFindingOrFeature enumAbnormalLinesFindingOrFeature)
	{
		switch(enumAbnormalLinesFindingOrFeature)
		{
		case RETICULONODULAR_PATTERN: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.RETICULONODULAR_PATTERN_112065.getValue();break;
		case AIR_FLUID_LEVEL: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.AIR_FLUID_LEVEL_112104.getValue();break;
		case CORONA_RADIATA: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.CORONA_RADIATA_112105.getValue();break;
		case HONEYCOMB_PATTERN: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.HONEYCOMB_PATTERN_112106.getValue();break;
		case FLEISCHNERS_LINES: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.FLEISCHNERS_LINES_112107.getValue();break;
		case INTRALOBULAR_LINES: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.INTRALOBULAR_LINES_112108.getValue();break;
		case KERLEY_A_LINE: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.KERLEY_A_LINE_112109.getValue();break;
		case KERLEY_B_LINE: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.KERLEY_B_LINE_112110.getValue();break;
		case KERLEY_C_LINES: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.KERLEY_C_LINES_112111.getValue();break;
		case PARENCHYMAL_BAND: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.PARENCHYMAL_BAND_112112.getValue();break;
		case PLATE_LIKE_ATELECTASIS: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.PLATE_LIKE_ATELECTASIS_D2_60302.getValue();break;
		case RETICULAR_PATTERN: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.RETICULAR_PATTERN_112113.getValue();break;
		case SEPTAL_LINES: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.SEPTAL_LINES_112114.getValue();break;
		case SUBPLEURAL_LINE: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.SUBPLEURAL_LINE_112115.getValue();break;
		case TRAMLINE_SHADOW: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.TRAMLINE_SHADOW_112116.getValue();break;
		case TUBULAR_SHADOW: this.strCodeValue = EnumCV_AbnormalLinesFindingOrFeature.TUBULAR_SHADOW_112117.getValue();break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumAbnormalLinesFindingorFeature Object of EnumCM_AbnormalLinesFindingorFeature represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_AbnormalLinesFindingOrFeature enumAbnormalLinesFindingOrFeature)
	{
		switch(enumAbnormalLinesFindingOrFeature)
		{
		case PLATE_LIKE_ATELECTASIS : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.PLATE_LIKE_ATELECTASIS.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for AbnormalLinesFindingOrFeature
	 * @param enumAbnormalLinesFindingOrFeature Object of EnumCM_AbnormalLinesFindingOrFeature.
	 */
	public void setAbnormalLinesFindingOrFeature(EnumCM_AbnormalLinesFindingOrFeature enumAbnormalLinesFindingOrFeature)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumAbnormalLinesFindingOrFeature.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_AbnormalLinesFindingOrFeature.PLATE_LIKE_ATELECTASIS.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumAbnormalLinesFindingOrFeature);
	}
}
